package com.huimv.guowei.admin.group.controller;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.group.entity.GroupDuckInfo;
import com.huimv.guowei.admin.group.entity.GroupEatingGenerate;
import com.huimv.guowei.admin.group.entity.GroupEgg;
import com.huimv.guowei.admin.group.entity.GroupRank;
import com.huimv.guowei.admin.group.entity.vo.GroupEatingVo;
import com.huimv.guowei.admin.group.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 平养采食记录定时生成 前端控制器
 * </p>
 *
 * @author author
 * @since 2025-02-18
 */
@RestController
@RequestMapping("/group-eating-generate")
@CrossOrigin
public class GroupEatingGenerateController {

    @Autowired
    private IGroupRankService rankService;
    @Autowired
    private IGroupEggService eggService;
    @Autowired
    private IGroupEatingService eatingService;
    @Autowired
    private IGroupEatingGenerateService generateService;
    @Autowired
    private IGroupDuckInfoService duckInfoService;

    @RequestMapping("/test")
    public void saveOnlineDevice(@RequestBody Map<String, String> paramsMap) throws ParseException {
        String start = paramsMap.get("start");
        String end = paramsMap.get("end");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        QueryWrapper<GroupDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("is_leave", 0);
        List<GroupDuckInfo> duckInfos = duckInfoService.list(queryWrapper);
        if (duckInfos.size() != 0) {
            for (GroupDuckInfo duckInfo : duckInfos) {
                String deviceCode = duckInfo.getDeviceCode();
                String batchNum = duckInfo.getBatchNum();
                QueryWrapper<GroupEgg> eggQueryWrapper = new QueryWrapper<>();
                eggQueryWrapper.eq("device_code", deviceCode).eq("batch_num", batchNum)
                        .orderByDesc("id")
                        .last(" limit 1");
                GroupEgg groupEgg = eggService.getOne(eggQueryWrapper);
                GroupEatingVo eatingCount = eatingService.getEatingCount(deviceCode, batchNum);

                GroupRank groupRank = new GroupRank();
                groupRank.setBatchNum(batchNum);
                groupRank.setDeviceCode(deviceCode);
                groupRank.setDateTime(sdf.parse(end));
                groupRank.setFarmId(21);

                QueryWrapper<GroupEgg> queryWrapper1 = new QueryWrapper<>();
                queryWrapper1.eq("device_code", deviceCode).eq("batch_num", batchNum)
                        .between("create_time",start,end);
                queryWrapper1.select(" IFNULL(sum(egg_num),'0') eggNum");
                GroupEgg one = eggService.getOne(queryWrapper1);
                groupRank.setDayEgg(one.getEggNum());

                QueryWrapper<GroupEatingGenerate> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("device_code", deviceCode).eq("batch_num", batchNum)
                        .ge("create_time", "2025-02-20 00:00:00");
                queryWrapper2.select(" IFNULL(sum(eating_value),'0') eatingValue");
                GroupEatingGenerate one1 = generateService.getOne(queryWrapper2);
                groupRank.setDayEating(one1.getEatingValue());



                if (ObjectUtil.isEmpty(groupEgg) || groupEgg.getCreateTime().compareTo(sdf.parse(start)) < 0) {
                    groupRank.setEggNum(0);
                    groupRank.setEatingValue("0");
                    groupRank.setEggWeight("0");
                    groupRank.setEatingEgg("0");
                } else {
                    groupRank.setEggNum(groupEgg.getEggCount());
                    if (groupEgg.getEggCount() == 0) {
                        groupRank.setEatingValue("0");
                        groupRank.setEggWeight("0");
                        groupRank.setEatingEgg("0");
                    } else {
                        double v = Double.valueOf(eatingCount.getValues()) / (groupEgg.getEggCount() * 70);
                        DecimalFormat def = new DecimalFormat("0.00");
                        groupRank.setEatingEgg(def.format(v));
                        groupRank.setEggWeight(String.valueOf(groupEgg.getEggCount() * 70));
                    }
                }

                groupRank.setEatingValue(eatingCount.getValues());

                rankService.save(groupRank);
            }
        }

    }
}
