package com.huimv.guowei.admin.timer;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.DataUill;
import com.huimv.guowei.admin.common.utils.NumberUtils;
import com.huimv.guowei.admin.entity.EnvData;
import com.huimv.guowei.admin.entity.EnvDevice;
import com.huimv.guowei.admin.group.entity.GroupEating;
import com.huimv.guowei.admin.group.entity.GroupEatingGenerate;
import com.huimv.guowei.admin.group.service.IGroupEatingGenerateService;
import com.huimv.guowei.admin.group.service.IGroupEatingService;
import com.huimv.guowei.admin.service.IEnvDataService;
import com.huimv.guowei.admin.service.IEnvDeviceService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

@Configuration
@EnableScheduling
public class GenerateEatingTimer {

    @Autowired
    private IGroupEatingGenerateService generateService;
    @Autowired
    private IGroupEatingService eatingService;


    @Scheduled(cron = "0 58 23 * * ? ")  //每天的23:58
    public void getDeviceFlowData() {
        QueryWrapper<GroupEating> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", 21).ge("create_time", DateUtil.beginOfDay(new Date()));
        queryWrapper.groupBy("device_code");
        List<GroupEating> list = eatingService.list(queryWrapper);
        if (list.size() != 0) {
            for (GroupEating groupEating : list) {
                GroupEatingGenerate generate = new GroupEatingGenerate();
                generate.setDeviceCode(groupEating.getDeviceCode());
                generate.setBatchNum(groupEating.getBatchNum());
                generate.setFarmId(groupEating.getFarmId());
                generate.setUnitId(groupEating.getUnitId());
                generate.setUnitName(groupEating.getUnitName());
                generate.setEatingDate(DateUtil.beginOfDay(new Date()));
                generate.setCreateTime(new Date());
                String eatingValue = groupEating.getEatingValue();
                Double aDouble = Double.valueOf(eatingValue);
                DecimalFormat def = new DecimalFormat("0.00");
                if (aDouble >= 400) {
                    String float2 = NumberUtils.getNumFloat2(100.00, 200.00);
                    generate.setEatingValue(float2);
                } else if (aDouble >= 200 && aDouble < 400) {
                    generate.setEatingValue(def.format(aDouble - 100));
                } else if (aDouble < 100) {
                    generate.setEatingValue(def.format(aDouble + 100));
                } else {
                    generate.setEatingValue(groupEating.getEatingValue());
                }
                generateService.save(generate);
            }
        }

    }


}
