package com.huimv.guowei.admin.timer;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.guowei.admin.common.utils.DataUill;
import com.huimv.guowei.admin.entity.EnvDevice;
import com.huimv.guowei.admin.entity.EnvDeviceOnline;
import com.huimv.guowei.admin.entity.EnvMoveCall;
import com.huimv.guowei.admin.entity.RawData;
import com.huimv.guowei.admin.group.entity.*;
import com.huimv.guowei.admin.group.entity.vo.GroupEatingVo;
import com.huimv.guowei.admin.group.service.*;
import com.huimv.guowei.admin.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.List;

@Component
@EnableScheduling
public class GroupRankTimer {


    @Autowired
    private IGroupRankService rankService;
    @Autowired
    private IGroupEggService eggService;
    @Autowired
    private IGroupEatingService eatingService;
    @Autowired
    private IGroupEatingGenerateService generateService;
    @Autowired
    private IGroupDuckInfoService duckInfoService;


//    @Scheduled(cron = "*/5 * * * * ?")
    @Scheduled(cron = "0 59 23 * * ?")
    private void saveOnlineDevice(){
        QueryWrapper<GroupDuckInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("is_leave", 0);
        List<GroupDuckInfo> duckInfos = duckInfoService.list(queryWrapper);
        if (duckInfos.size() != 0) {
            for (GroupDuckInfo duckInfo : duckInfos) {
                String deviceCode = duckInfo.getDeviceCode();
                String batchNum = duckInfo.getBatchNum();
                QueryWrapper<GroupEgg> eggQueryWrapper = new QueryWrapper<>();
                eggQueryWrapper.eq("device_code", deviceCode).eq("batch_num", batchNum)
                        .orderByDesc("id")
                        .last(" limit 1");
                GroupEgg groupEgg = eggService.getOne(eggQueryWrapper);
                GroupEatingVo eatingCount = eatingService.getEatingCount(deviceCode,batchNum);

                GroupRank groupRank = new GroupRank();
                groupRank.setBatchNum(batchNum);
                groupRank.setDeviceCode(deviceCode);
                groupRank.setDateTime(new Date());
                groupRank.setFarmId(21);

                QueryWrapper<GroupEgg> queryWrapper1 = new QueryWrapper<>();
                queryWrapper1.eq("device_code", deviceCode).eq("batch_num", batchNum).ge("create_time", DateUtil.beginOfDay(new Date()));
                queryWrapper1.select(" IFNULL(sum(egg_num),'0') eggNum");
                GroupEgg one = eggService.getOne(queryWrapper1);
                groupRank.setDayEgg(one.getEggNum());

                QueryWrapper<GroupEatingGenerate> queryWrapper2 = new QueryWrapper<>();
                queryWrapper2.eq("device_code", deviceCode).eq("batch_num", batchNum).ge("create_time", DateUtil.beginOfDay(new Date()));
                queryWrapper2.select(" convert(IFNULL(sum(eating_value),'0'),decimal(10,2)) eatingValue");
                GroupEatingGenerate one1 = generateService.getOne(queryWrapper2);
                groupRank.setDayEating(one1.getEatingValue());


                if (ObjectUtil.isEmpty(groupEgg) || groupEgg.getCreateTime().compareTo(DateUtil.beginOfDay(new Date())) < 0) {
                    groupRank.setEggNum(0);
                    groupRank.setEatingValue("0");
                    groupRank.setEggWeight("0");
                    groupRank.setEatingEgg("0");
                } else {
                    groupRank.setEggNum(groupEgg.getEggCount());
                    if (groupEgg.getEggCount() == 0) {
                        groupRank.setEatingValue("0");
                        groupRank.setEggWeight("0");
                        groupRank.setEatingEgg("0");
                    } else {
                        double v = Double.valueOf(eatingCount.getValues()) / (groupEgg.getEggCount() * 70);
                        DecimalFormat def = new DecimalFormat("0.00");
                        groupRank.setEatingEgg(def.format(v));
                        groupRank.setEggWeight(String.valueOf(groupEgg.getEggCount() * 70));
                    }
                }

                groupRank.setEatingValue(eatingCount.getValues());

                rankService.save(groupRank);
            }
        }

    }

}
